#pragma once
#ifndef _AXCONTROLDLG_H_
#define _AXCONTROLDLG_H_

#include<vector>
#include "base_include\atlcontrols.H"
#include "resource.H"
using namespace std;

//A simple InsertControl dialog in lieu of OLEUIInsertObject()
//
//
//------------------------------------------------------------------------------------------------
class CAXControlInsertDialog : public CDialogImpl<CAXControlInsertDialog>
{
public:
	enum { IDD = IDD_INSERTCONTROL };
    CLSID	m_clsid;

public:
	BEGIN_MSG_MAP(CAXControlInsertDialog)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
		COMMAND_ID_HANDLER(IDOK, OnOK)
		COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
		COMMAND_CODE_HANDLER(LBN_SELCHANGE, OnListChange)
		COMMAND_CODE_HANDLER(LBN_DBLCLK, OnListItemDblClk)
	END_MSG_MAP()	

	LRESULT OnInitDialog(UINT , WPARAM , LPARAM , BOOL& bHandled);
	LRESULT OnDestroy(UINT , WPARAM , LPARAM , BOOL& bHandled);

	LRESULT OnListChange(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnListItemDblClk(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	
	LRESULT OnOK(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnCancel(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	
private:
	struct InsertDlgInfo
	{
		InsertDlgInfo():m_clsid(CLSID_NULL),m_nIndex(0){}

		CLSID	m_clsid;
		int		m_nIndex;
	};

	HRESULT PopulateList();
	void	ClearList();
	HRESULT GetClassServerPath( REFCLSID clsid);
	
private:
	vector<InsertDlgInfo>			m_vecInfo;
	CComPtr<ICatInformation>		m_spCatInfo;

};
//------------------------------------------------------------------------------------------------

#endif