//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//Copyright 1999 Dharma Shukla.

//Keep in mind that I wrote this code just for fun :-) 
//Use it at your own risk! 

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#pragma once
#ifndef _CONTEXT_MENU_H_
#define _CONTEXT_MENU_H_

//quick & dirty class for a resource based context menu
//------------------------------------------------------------------------------------------------------------------

class CContextMenu
{
public:
	CContextMenu() : m_hMenu(NULL){}
	~CContextMenu(){}

public:
	HMENU GetMenu() const { return m_hMenu; }

	BOOL Load(HINSTANCE hInst,UINT nMenuID)
	{
		return (m_hMenu = ::LoadMenu(hInst,MAKEINTRESOURCE(nMenuID)))? TRUE:FALSE ;
	}
	
	BOOL TrackSubMenu(int x, int y,HWND hWndOwner,UINT nFlags = TPM_RIGHTALIGN)
	{
		return ::TrackPopupMenu(GetSubMenu(m_hMenu,0),nFlags,x,y,0,hWndOwner,NULL);
	}
	
	BOOL Track(int x, int y,HWND hWndOwner,UINT nFlags = TPM_RIGHTALIGN)
	{
		return ::TrackPopupMenu(m_hMenu,nFlags,x,y,0,hWndOwner,NULL);
	}

	BOOL Delete(UINT nPos, UINT nFlags = MF_BYCOMMAND)
	{
		return ::DeleteMenu(m_hMenu,nPos,nFlags);
	}
	
	BOOL Insert(UINT nPos,UINT nID,LPCTSTR lpNew, UINT nFlags = MF_BYCOMMAND|MF_STRING)
	{
		return ::InsertMenu(m_hMenu,nPos,nFlags,nID,lpNew);
	}

	int ItemCount()
	{
		return ::GetMenuItemCount(m_hMenu);
	}
	BOOL Destroy()
	{
		BOOL b = ::DestroyMenu(m_hMenu);
		m_hMenu = NULL;
		return b;
	}
	
	void operator =(const HMENU& hMenu)
	{
		if(m_hMenu)
		{
			Destroy();
		}
		m_hMenu = hMenu;
	}

private:
	HMENU m_hMenu;
};

//------------------------------------------------------------------------------------------------------------------

#endif