//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//Copyright 1999 Dharma Shukla.

//Keep in mind that I wrote this code just for fun :-) 
//Use it at your own risk! 

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#include "StdAfx.H"
#include "ContainerFrame.H"
#include "browsetab.h"
#include "PersistBag.H"
#include "Base_Include\filedlg.H"
#include "ScriptSite.H"
#include "AboutBox.H"

//--------------------------------------------------------------------------------------------------------------------

CContainerFrame::CContainerFrame():		m_pFormObj(0),
										m_pPropBagObj(0),
										m_bSavedOnce(false),
										m_pBrowseTabContainer(0),
										m_bEnableModeless(0)

{
	m_pBrowseTabContainer = new CBrowseTabContainer();
	lstrcpy(m_szFileName,_T(""));
	m_wndFormSite = new CAxWindowHandle(this);
}

//--------------------------------------------------------------------------------------------------------------------
CContainerFrame::~CContainerFrame()
{
	if(m_pBrowseTabContainer)
	{
		delete m_pBrowseTabContainer;
		m_pBrowseTabContainer = 0;
	}
	if(m_wndFormSite)
	{
		delete m_wndFormSite;m_wndFormSite = 0;
	}
}
//--------------------------------------------------------------------------------------------------------------------
HRESULT CContainerFrame::OnToolSelected(CComBSTR& bstrCLSID)
{
	if(m_pFormObj)
	{
		m_pFormObj->PutSelectionInfo(bstrCLSID); 
	}

	return 0;
}

//--------------------------------------------------------------------------------------------------------------------
LRESULT CContainerFrame::OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	if(!m_pPropBagObj)
	{
		HRESULT hr = m_pPropBagObj->CreateInstance(&m_pPropBagObj);
		
		if(FAILED(hr)){	return 0L; }

		m_pPropBagObj->AddRef(); 
	}

	RECT rc,rcToolWindow,rcBrowser;
	GetClientRect(&rc);

	//menubar
	m_wndToolPanel.Create(m_hWnd,rc);

	//create the toolwindow
	rcToolWindow.top = rc.top + 100;
	rcToolWindow.right = rc.left + 100;
	rcToolWindow.bottom = rc.bottom - 500;
	
	m_wndControlToolBox.Init(this);
	m_wndControlToolBox.Create(m_hWnd,rcToolWindow,_T("Controls"),0,0,0);
			
	
	//create the prop-browser
	rcBrowser.top = rc.top + 100;
	rcBrowser.left = rc.right - 250;
	rcBrowser.bottom = rc.bottom - 500;

	m_pBrowseTabContainer->Create(m_hWnd,rcBrowser);

	//create Form
	CreateForm();

	m_Status.Create(this,1, m_hWnd, &rc);
	m_Status.SetText(0, _T("Ready!"), 0);  

	m_wndFormSite->SetActiveWindow();
	m_wndFormSite->SetFocus();

	return 0L;
}
//--------------------------------------------------------------------------------------------------------------------

LRESULT CContainerFrame::OnSize(UINT /* uMsg */, WPARAM /* wParam */, LPARAM /* lParam */, BOOL& /* lResult */)
{
	RECT rc;
	GetClientRect(&rc);
	
	m_wndToolPanel.MoveWindow(rc.left, rc.top, rc.right - rc.left, rc.top+30);
	m_wndControlToolBox.MoveWindow(rc.left, rc.top+100, rc.left + 100, rc.bottom-300);
	m_pBrowseTabContainer->MoveWindow(rc.right -320, rc.top+100, 300, rc.bottom-200);

	m_wndFormSite->CenterWindow();
	
	if(m_Status.m_hWnd)
	{
		rc.top = rc.bottom - 30;
		m_Status.SetWindowPos(NULL,rc.left,rc.top,rc.right - rc.left,rc.bottom - rc.top, SWP_NOZORDER | SWP_NOACTIVATE);
	}
	
	return 0;
}
//-------------------------------------------------------------------------------------------------------------------------------

LRESULT CContainerFrame::OnFileExit(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	DestroyWindow();
	return 0;
}
//-------------------------------------------------------------------------------------------------------------------------------
HRESULT CContainerFrame::DeleteForm()
{
	if(m_wndFormSite)
	{
		if(m_wndFormSite->GetChildControlHwnd())
		{
			m_wndFormSite->UnsubclassControl();
		}
		if(m_wndFormSite->IsWindow())
		{
			m_wndFormSite->DestroyWindow();
			m_wndFormSite->m_hWnd = 0;
		}
	}

	if(m_pFormObj)
	{
		m_pFormObj->Release();
		m_pFormObj = 0;
	}

	return S_OK;
}
//-------------------------------------------------------------------------------------------------------------------------------
HRESULT CContainerFrame::CreateForm()
{
	if(m_wndFormSite->m_hWnd){ DeleteForm(); }

	HRESULT hr = S_OK;

	RECT rc;
	GetClientRect(&rc);
		
	rc.left += 40;
	rc.top  += 50;
	rc.right = rc.left + 500;
	rc.bottom = rc.top + 500; 
	
	//create Form Window
	m_wndFormSite->Create(m_hWnd, rc, _T(""),	WS_CAPTION|
												WS_VISIBLE| 
												WS_OVERLAPPED | 
												WS_CLIPSIBLINGS |
												WS_CLIPCHILDREN | 
												WS_MINIMIZEBOX|
												WS_MAXIMIZEBOX |
												WS_THICKFRAME,
												WS_EX_LEFT|
												WS_EX_LTRREADING|
												WS_EX_RIGHTSCROLLBAR|
												WS_EX_APPWINDOW|
												WS_EX_WINDOWEDGE);

	m_wndFormSite->SetWindowText(_T("Form"));
	m_wndFormSite->CenterWindow();
	
	//Create Form Object
	if(!m_pFormObj)
	{
		m_pFormObj->CreateInstanceWithData(&m_pFormObj,this);
		m_pFormObj->AddRef();
	}
	m_wndFormSite->InitializeSite();

	CComPtr<IUnknown> spUnkCtl;
	if(m_pFormObj)
	{
		m_pFormObj->QueryInterface(IID_IUnknown,(void**)&spUnkCtl);
	}

	CComPtr<IAxWinHostWindow> spFormSite;
	m_wndFormSite->QueryHost(&spFormSite);
	
	// Attach the Form control to the site
	if(spFormSite && spUnkCtl)
	{
		spFormSite->AttachControl(spUnkCtl, *m_wndFormSite);
	}

	//Setting the extended properties now !
	if(SUCCEEDED(hr)) 
	{
		LPOLESTR pszCLSID = 0;
		::StringFromCLSID(CLSID_Form,&pszCLSID);
	
		m_wndFormSite->m_pExtendedDispatchObj->SetCLSIDOfControl(CComBSTR(pszCLSID));
		
		CoTaskMemFree(pszCLSID);pszCLSID = 0;
	}
	
	return hr;
}
//-------------------------------------------------------------------------------------------------------------------------------
#ifdef __DOMEnabled_
HRESULT CContainerFrame::LoadXMLFile(LPTSTR pszFileName)
{
	CComPtr<IXMLDOMDocument> pDoc;
	HRESULT hr = pDoc.CoCreateInstance(__uuidof(DOMDocument));
	if (FAILED(hr)) return hr;

	VARIANT_BOOL b;
	hr = pDoc->load(CComVariant(pszFileName), &b);
	if (FAILED(hr)) return hr;

	CComPtr<IXMLDOMElement> pRoot;
	hr = pDoc->get_documentElement(&pRoot);
	if (FAILED(hr)) return hr;

	CComQIPtr<IXMLDOMNode> pNode(pRoot);
	
	CComPtr<IXMLDOMNodeList>spList;
	hr = pNode->selectNodes(CComBSTR("Control"),&spList);
	if (FAILED(hr)) return hr;

	//if the form exists delete it
	DeleteForm();	

	//Create the Form
	CreateForm();		

	//Extended Properties
	CComPtr<IPersistPropertyBag> spExtendedPPB;
	m_wndFormSite->m_pExtendedDispatchObj->SetDirty(VARIANT_FALSE);
			
	hr = m_wndFormSite->m_pExtendedDispatchObj->QueryInterface(&spExtendedPPB);
	if (FAILED(hr)) return hr;

	CComPtr<IPropertyBag> pPropBag;
	hr = GetPropertyBagFromXML(pDoc, pRoot, &pPropBag);
	if (FAILED(hr)) return hr;

	hr = spExtendedPPB->Load(pPropBag, NULL);
	if (FAILED(hr)) return hr;

	m_wndFormSite->m_pExtendedDispatchObj->SetDirty(VARIANT_TRUE);				

	//ok. now get the extended properties for the Form's window rect
	long nWidth = 0;long nHeight = 0;RECT rc;
	m_wndFormSite->m_pExtendedDispatchObj->get_PositionX(&rc.left);
	m_wndFormSite->m_pExtendedDispatchObj->get_PositionY(&rc.top);
	m_wndFormSite->m_pExtendedDispatchObj->get_SizeX(&nWidth);
	m_wndFormSite->m_pExtendedDispatchObj->get_SizeY(&nHeight);
	m_wndFormSite->SetWindowPos(HWND_TOP,rc.left,rc.top,nWidth,nHeight,SWP_NOZORDER);	

	CComPtr<IPersistPropertyBag> spPersistPropBag;
	hr = m_wndFormSite->QueryControl(&spPersistPropBag);
	if (FAILED(hr)) return hr;

	CComPtr<IPropertyBag> pPropBag2;
	hr = GetPropertyBagFromXML(pDoc, pRoot, &pPropBag2);
	if (FAILED(hr)) return hr;

	hr = spPersistPropBag->Load(pPropBag2, NULL);
	if (FAILED(hr)) return hr;

	//Now Load all the child controls of the Form
	return m_pFormObj->OpenXML(pDoc.p,spList.p);
}
#endif
//-----------------------------------------------------------------------------------------------
HRESULT CContainerFrame::LoadTextFile(LPTSTR pszFileName)
{
	if(!m_pPropBagObj){ return E_FAIL; }
	m_pPropBagObj->ResetPropertyBag();
	//Load the Form's properties
	CComPtr<IPropertyBag> spBag;
	HRESULT hr = m_pPropBagObj->QueryInterface(&spBag);

	if(FAILED(hr))  return hr; 

	//OpenFile opens the file sand initializes the reader
	if(FAILED(m_pPropBagObj->GetReader().OpenFile(pszFileName))) return E_FAIL;


	//if the form exists delete it
	DeleteForm();	

	//Create the Form
	CreateForm();		

	//Load all the persisted properties
	CComPtr<IPersistPropertyBag> spPersistPropBag;
	hr = m_wndFormSite->QueryControl(&spPersistPropBag);
			
	m_pPropBagObj->TheObjectIsAControl(); // set the current clsid of the bag for the control

	//Ambient Properties
	CComPtr<IPersistPropertyBag> spAmbientPPB;
	if(m_wndFormSite->m_pSiteObject)
	{
		CComPtr<IUnknown> spUnk;
		m_wndFormSite->QueryHost(&spUnk);
		CComQIPtr<IAxWinAmbientDispatch> spAmbientDisp(spUnk);	
		if(spAmbientDisp) 
		{
			hr = spAmbientDisp->QueryInterface(&spAmbientPPB);
			if(SUCCEEDED(hr)) //Load Ambients
			{	
				hr = spAmbientPPB->InitNew();
				hr = spAmbientPPB->Load(spBag,NULL);
			}
		}
	}

	//Extended Properties
	CComPtr<IPersistPropertyBag> spExtendedPPB;
	m_wndFormSite->m_pExtendedDispatchObj->SetDirty(VARIANT_FALSE);
	hr = m_wndFormSite->m_pExtendedDispatchObj->QueryInterface(&spExtendedPPB);

	if(SUCCEEDED(hr)) 
	{	
		//Load Extended Properties
		hr = spExtendedPPB->InitNew();
		hr = spExtendedPPB->Load(spBag,NULL);
		
		m_wndFormSite->m_pExtendedDispatchObj->SetDirty(VARIANT_TRUE);				

		//ok. now get the extended properties for the Form's window rect
		if(SUCCEEDED(hr))
		{
			long nWidth = 0;long nHeight = 0;RECT rc;
			m_wndFormSite->m_pExtendedDispatchObj->get_PositionX(&rc.left);
			m_wndFormSite->m_pExtendedDispatchObj->get_PositionY(&rc.top);
			m_wndFormSite->m_pExtendedDispatchObj->get_SizeX(&nWidth);
			m_wndFormSite->m_pExtendedDispatchObj->get_SizeY(&nHeight);
			m_wndFormSite->SetWindowPos(HWND_TOP,rc.left,rc.top,nWidth,nHeight,SWP_NOZORDER);	

		}
		spExtendedPPB.Release();
	}
	
	//Load the native properties
	hr = spPersistPropBag->InitNew();
	hr = spPersistPropBag->Load(spBag,NULL);
	
	//Now Load all the child controls of the Form
	m_pFormObj->OpenText();

	return hr;
}
//-------------------------------------------------------------------------------------------------------------------------------
LRESULT CContainerFrame::OnFileOpen(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(m_pFormObj && m_bSavedOnce)
	{
		OnFileClose(0,0,0,bHandled);
	}

	#ifdef __DOMEnabled_
		CFileOpenDialog dlg(__T("Container Files\0*.XML\0\0"));
	#else
		CFileOpenDialog dlg(__T("Container Files\0*.con\0\0"));
	#endif

	if(dlg.DoModal())
	{
		if(!dlg.lpstrFile){ return E_POINTER; }
		if(lstrlen(dlg.lpstrFile) == 0){ return E_FAIL; }

	#ifdef __DOMEnabled_
		LoadXMLFile(dlg.lpstrFile);
	#else
		LoadTextFile(dlg.lpstrFile);
	#endif
	
	}

	m_wndFormSite->SetActiveWindow();
	m_wndFormSite->SetFocus();

	return 0;
}

//-------------------------------------------------------------------------------------------------------------------------------
LRESULT CContainerFrame::OnFileClose(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(!m_pFormObj) return 0L;
	
	if(!m_bSavedOnce)
	{
		#ifdef __DOMEnabled_
			CFileOpenDialog dlg(__T("Container Files\0*.XML\0\0"));
		#else
			CFileOpenDialog dlg(__T("Container Files\0*.con\0\0"));
		#endif
		dlg.DoModal();
		lstrcpy(m_szFileName,dlg.lpstrFile);
		
		if(!dlg.lpstrFile || lstrlen(dlg.lpstrFile) == 0){ return 0L; }

		m_bSavedOnce = true;
	}
	
	OnFileSave(0, 0, 0, bHandled);
	m_pFormObj->Close();
	DeleteForm();

	return 0;
}

//-------------------------------------------------------------------------------------------------------------------------------
#ifdef __DOMEnabled_
HRESULT CContainerFrame::SaveXMLFile(LPTSTR pszFileName)
{
	CComPtr<IXMLDOMDocument> pDoc;
	HRESULT hr = pDoc.CoCreateInstance(__uuidof(DOMDocument));
	if (FAILED(hr)) return hr;

	//Root of the Doc
	CComPtr<IXMLDOMElement> pElem;
	hr = pDoc->createElement(CComBSTR(L"Form1"), &pElem);
	if (FAILED(hr)) return hr;

	hr = pDoc->putref_documentElement(pElem);
	if (FAILED(hr)) return hr;

	CComPtr<IXMLDOMElement> pRoot;
	hr = pDoc->get_documentElement(&pRoot);
	if (FAILED(hr)) return hr;
			
	//Ambient Properties
	CComPtr<IPersistPropertyBag> spAmbientPPB;
	CComPtr<IUnknown> spUnk;
	m_wndFormSite->QueryHost(&spUnk);

	CComQIPtr<IAxWinAmbientDispatch> spAmbientDisp(spUnk);	
	if(spAmbientDisp) 
	{
		hr = spAmbientDisp->QueryInterface(&spAmbientPPB);
	}
	//Extended Properties
	CComPtr<IPersistPropertyBag> spExtendedPPB;
	hr = m_wndFormSite->m_pExtendedDispatchObj->QueryInterface(&spExtendedPPB);
	if (FAILED(hr)) return hr;
	
	//Native
	CComPtr<IPersistPropertyBag> spPersistPropBag;
	hr = m_wndFormSite->QueryControl(&spPersistPropBag);
	if (FAILED(hr)) return hr;

	hr = spPersistPropBag->InitNew();
	if (FAILED(hr)) return hr;

	//Save Ambient Properties
	//hr = SaveToXML(pDoc.p, pRoot.p, spAmbientPPB, TRUE, TRUE);
	//if (FAILED(hr)) return hr;

	//Save Extended Properties
	hr = SaveToXML(pDoc.p, pElem.p, spExtendedPPB, TRUE, TRUE);
	if (FAILED(hr)) return hr;

	//Save Native Properties
	hr = SaveToXML(pDoc.p, pElem.p, spPersistPropBag, TRUE, TRUE);
	if (FAILED(hr)) return hr;

	//Now tell the form to persist its child controls
	hr = m_pFormObj->SaveXML(pDoc.p);
	if (FAILED(hr)) return hr;
	
	m_bSavedOnce = true;
	
	return pDoc->save(CComVariant(pszFileName));
}
#endif
//-------------------------------------------------------------------------------------------------------------------------------
HRESULT CContainerFrame::SaveTextFile(LPTSTR pszFileName)
{
	if(!m_pPropBagObj){ return 0L; }
	
	//Load the Form's properties
	CComPtr<IPropertyBag> spBag;
	HRESULT hr = m_pPropBagObj->QueryInterface(&spBag);
	if(FAILED(hr)) { return 0L; }

	//create the file to write
	m_pPropBagObj->GetWriter().CreateFile(pszFileName);

	//First, write all the CLSIDs of the controls on the top of the file
	m_pPropBagObj->GetWriter().WriteControlCount(m_pFormObj->GetControlCount() + 1); 

	//Now Store the Form's properties
	CComPtr<IPersistPropertyBag> spPersistPropBag;
	hr = m_wndFormSite->QueryControl(&spPersistPropBag);

	if(SUCCEEDED(hr))
	{
		CLSID clsid;
		spPersistPropBag->GetClassID(&clsid);
		//store the CLSID of the Form
		m_pPropBagObj->GetWriter().WriteHeader(clsid); 
		//store all the CLSID's of the child controls of the Form
		m_pFormObj->WriteControlHeaders();

		//Ambient Properties
		CComPtr<IPersistPropertyBag> spAmbientPPB;

		CComPtr<IUnknown> spUnk;
		m_wndFormSite->QueryHost(&spUnk);

		CComQIPtr<IAxWinAmbientDispatch> spAmbientDisp(spUnk);	
		if(spAmbientDisp) 
		{
			hr = spAmbientDisp->QueryInterface(&spAmbientPPB);
		}
		
		//Extended Properties
		CComPtr<IPersistPropertyBag> spExtendedPPB;
		
		hr = m_wndFormSite->m_pExtendedDispatchObj->QueryInterface(&spExtendedPPB);
		
		//write the header for each control first
		m_pPropBagObj->GetWriter().WriteControlHeader(clsid);			
		
		//Save the Ambient Properties
		if(spAmbientPPB)
		{
			hr = spAmbientPPB->Save(spBag,TRUE,TRUE);
		}
		
		//Save Extended Properties too
		if(spExtendedPPB)
		{
			hr = spExtendedPPB->Save(spBag,TRUE,TRUE);
		}

		//now save the control's native properties
		hr = spPersistPropBag->Save(spBag,TRUE,TRUE);
		

		//write the footer for each control first
		m_pPropBagObj->GetWriter().WriteControlFooter();				
		
		spPersistPropBag.Release();
	}

	//Now tell the form to persist its child controls
	if(SUCCEEDED(m_pFormObj->SaveText()))
	{
		m_bSavedOnce = true;
	}
	
	m_pPropBagObj->GetWriter().CloseFile();

	return hr;
}
//-------------------------------------------------------------------------------------------------------------------------------
LRESULT CContainerFrame::OnFileSave(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(m_bSavedOnce){ return 0L; }
	if(!m_pFormObj) return 0L;

	#ifdef __DOMEnabled_
	    LPCTSTR pszInitialFile = lstrlen(m_szFileName) ? m_szFileName : _T("Untitled.XML") ;
		CFileSaveDialog dlg(__T("Container XML Files\0*.XML\0\0"), pszInitialFile, __T("XML"));
	#else
		LPCTSTR pszInitialFile = lstrlen(m_szFileName) ? m_szFileName : _T("Untitled.con") ;
		CFileSaveDialog dlg(__T("Container Files\0*.con\0\0"), pszInitialFile, __T("con"));
	#endif

	if(dlg.DoModal())
	{
		if(!dlg.lpstrFile){ return E_POINTER; }
		if(lstrlen(dlg.lpstrFile) == 0){ return E_FAIL; }
		
	#ifdef __DOMEnabled_
		SaveXMLFile(dlg.lpstrFile);		
	#else
		SaveTextFile(dlg.lpstrFile);		
	#endif
		m_bSavedOnce = true;
	}

	return 0;
}
//-------------------------------------------------------------------------------------------------------------------------------
void CContainerFrame::OnFinalMessage(HWND /*hWnd*/)
{
	if(m_pFormObj)
	{
		DeleteForm();
	}
	if(m_pPropBagObj)
	{
		m_pPropBagObj->Release();
		m_pPropBagObj = 0;
	}

	::PostQuitMessage(0);
}

//-------------------------------------------------------------------------------------------------------------------------------
LRESULT CContainerFrame::OnDestroy(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	if(m_pBrowseTabContainer)
	{
		delete m_pBrowseTabContainer;
		m_pBrowseTabContainer = 0;
	}
	if(m_wndFormSite)
	{
		DeleteForm();
	}
	return 0L;
}
//-------------------------------------------------------------------------------------------------------------------------------
LRESULT CContainerFrame::OnScripterShow(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(m_pFormObj)
	{
		BOOL b;
		m_pFormObj->OnShowScriptWindow(0,0,0, b);
	}
	return 0L;
}
//-------------------------------------------------------------------------------------------------------------------------------
LRESULT CContainerFrame::OnAddControl2ToolBox(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(m_wndControlToolBox.m_hWnd)
	{
		BOOL b;
		m_wndControlToolBox.OnMenuClick(0, ID_CONTROLDIALOG, 0, b);
	}
	return 0L;
}
//-------------------------------------------------------------------------------------------------------------------------------
LRESULT CContainerFrame::OnAbout(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	CAboutBox about;
	about.DoModal();
	return 0L;
}
//-------------------------------------------------------------------------------------------------------------------------------
HRESULT CContainerFrame::EnableOrDisableOwnedPopups(BOOL bEnable)
{
	m_bEnableModeless = bEnable;

	//enable/disable all the owned popups
	
	m_wndControlToolBox.EnableWindow(bEnable); 
	m_pBrowseTabContainer->EnableWindow(bEnable);
	::EnableWindow(m_pFormObj->m_hWnd,bEnable);
	EnableWindow(bEnable);

	return S_OK;
}
//-------------------------------------------------------------------------------------------------------------------------------
LRESULT CContainerFrame::OnSwitchToUserMode(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(!m_pFormObj) { return 0L; }
	
	CComPtr<IAxWinAmbientDispatch>spAmbDispatch;

	GetEnvelopeForSite()->OnUserModeChanged(VARIANT_TRUE);

	return 0L;
}
//-------------------------------------------------------------------------------------------------------------------------------
LRESULT CContainerFrame::OnStopAndGetBackToDesignMode(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(!m_pFormObj) { return 0L; }

	CComPtr<IAxWinAmbientDispatch>spAmbDispatch;

	GetEnvelopeForSite()->OnUserModeChanged(VARIANT_FALSE);
	StopAndGetBackToDesignMode();

	return 0L;
}
//-------------------------------------------------------------------------------------------------------------------------------
void CContainerFrame::SwitchToUserMode()
{
	m_pFormObj->ClearTheListOfDeletedSites();//extra caution
	m_pFormObj->DoBinarySave();//this will delete all embeddings too
	m_pFormObj->Close();//delete embeddings and shutdown scriting engine
	m_pFormObj->StartScriptingEngine(); //restart the scripting engine
	m_pFormObj->DoBinaryLoad();//this will create them back
	m_pFormObj->UpdateUserModesofHostedControls(VARIANT_TRUE);

	m_wndToolPanel.EnableToolBtn(ID_STOP, TRUE);
	m_wndToolPanel.EnableToolBtn(ID_RUN, FALSE);
	GetToolWindow().ShowWindow(SW_HIDE);
	GetBrowserContainer()->ShowWindow(SW_HIDE);

	GetEnvelopeForSite()->SetActiveWindow();
	GetEnvelopeForSite()->SetFocus();

	SetWindowText(_T("VBLite - Yet Another Control Container [Run]"));
}
//-------------------------------------------------------------------------------------------------------------------------------
void CContainerFrame::StopAndGetBackToDesignMode()
{
	m_pFormObj->Close();//delete embeddings and shutdown scriting engine
	m_pFormObj->StartScriptingEngine(); //restart the scripting engine	
	m_pFormObj->DoBinaryLoad(); //this will recreate them back
	m_pFormObj->FreeStream(); //this will free the stream so that next time we create a brand new one
	m_pFormObj->UpdateUserModesofHostedControls(VARIANT_FALSE);
	
	m_wndToolPanel.EnableToolBtn(ID_STOP, FALSE);
	m_wndToolPanel.EnableToolBtn(ID_RUN, TRUE);
	GetToolWindow().ShowWindow(SW_SHOW);
	GetBrowserContainer()->ShowWindow(SW_SHOW);
	GetBrowserContainer()->UpdateWindow();
		
	GetEnvelopeForSite()->SetActiveWindow();
	GetEnvelopeForSite()->SetFocus();

	SetWindowText(_T("VBLite - Yet Another Control Container [Design]"));
}
//-------------------------------------------------------------------------------------------------------------------------------
BOOL CContainerFrame::PreTranslateAccelerator(LPMSG pMsg, HRESULT& hRet)
{
	if(!m_pFormObj || !pMsg){ return FALSE; }
	
	//Our RunMode. Hit F5. Wahoo!!
	if (pMsg->message == WM_KEYDOWN && LOWORD(pMsg->wParam)== VK_F5)
	{
		BOOL b;
		OnSwitchToUserMode(0,0,m_hWnd, b);
	}

	return m_pFormObj->PreTranslateAccelerator(pMsg, hRet);

}
//-------------------------------------------------------------------------------------------------------------------------------
void CContainerFrame::SetDirty(bool b)
{
	GetBrowserContainer()->GetBrowseTab().GetExtendedBrowser().SetDirty(b);
}	
//-------------------------------------------------------------------------------------------------------------------------------
LPOLEINPLACEFRAMEINFO CContainerFrame::GetInPlaceFrameInfo() 
{
	return m_pFormObj->GetInPlaceFrameInfo() ; 
}
//-------------------------------------------------------------------------------------------------------------------------------
