//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//Copyright 1999 Dharma Shukla.

//Keep in mind that I wrote this code just for fun :-) 
//Use it at your own risk! 

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#pragma once
#ifndef _CONTAINERFRAME_H_
#define _CONTAINERFRAME_H_
#pragma comment(lib, "oledlg.lib")

#include "ToolWindow.H"
#include "resource.H"
#include "menubar.H"
#include "axWindowHandle.H"
#include "Base_Include\AxHostWindow2.H"
#include "EventDialog.H"
#include "Base_Include\comobj.H"
#include "Form.H"

#ifdef __DOMEnabled_
	#include "Base_Include\xmlpropbag.H"
#endif

class CPropertyBag;
class CBrowseTabContainer;
class CAxWindowHandle;
class CForm;	
//--------------------------------------------------------------------------------------------------------------------
class CContainerFrame :public CWindowImpl<CContainerFrame,CWindow, CFrameWinTraits >
{
public:
	CContainerFrame();
	~CContainerFrame();
	
	DECLARE_WND_CLASS_EX(NULL, 0, 0)

	BEGIN_MSG_MAP(CContainerFrame)
		MESSAGE_HANDLER(WM_CREATE, OnCreate)
		MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
		MESSAGE_HANDLER(WM_SIZE, OnSize)
		
		COMMAND_ID_HANDLER(ID_FILE_OPEN, OnFileOpen)
		COMMAND_ID_HANDLER(ID_FILE_CLOSE, OnFileClose)
		COMMAND_ID_HANDLER(ID_FILE_SAVE, OnFileSave)
		COMMAND_ID_HANDLER(ID_FILE_EXIT, OnFileExit)
		COMMAND_ID_HANDLER(ID_VIEW_SCRIPTER, OnScripterShow)
		COMMAND_ID_HANDLER(ID_OLE_INSERT_NEW, OnAddControl2ToolBox)
		COMMAND_ID_HANDLER(ID_RUN, OnSwitchToUserMode)
		COMMAND_ID_HANDLER(ID_STOP, OnStopAndGetBackToDesignMode)
		COMMAND_ID_HANDLER(ID_APP_ABOUT, OnAbout)
		CHAIN_MSG_MAP_ALT_MEMBER(m_wndToolPanel,2000)
	ALT_MSG_MAP(1)//statusbar
	END_MSG_MAP()
	
	void OnFinalMessage(HWND /*hWnd*/);
	
	HRESULT OnToolSelected(CComBSTR& bstrCLSID);
		
	LRESULT OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnDestroy(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnSize(UINT, WPARAM , LPARAM , BOOL& );
	
	LRESULT OnFileOpen(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnFileClose(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnFileSave(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnFileExit(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnScripterShow(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnAddControl2ToolBox(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	
	
	LRESULT OnSwitchToUserMode(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnStopAndGetBackToDesignMode(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	
	LRESULT OnAbout(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	
	void SwitchToUserMode();
	void StopAndGetBackToDesignMode();
	
#ifdef __DOMEnabled_
	HRESULT LoadXMLFile(LPTSTR pszFileName);
	HRESULT SaveXMLFile(LPTSTR pszFileName);
#endif
	HRESULT SaveTextFile(LPTSTR pszFileName);
	HRESULT LoadTextFile(LPTSTR pszFileName);

	HRESULT DeleteForm();
	HRESULT CreateForm();
	HRESULT EnableOrDisableOwnedPopups(BOOL bEnable);

	BOOL PreTranslateAccelerator(LPMSG pMsg, HRESULT& hRet);
	
	typedef CWinTraits<WS_CHILD|WS_VISIBLE|WS_CLIPSIBLINGS|CCS_NORESIZE|CCS_BOTTOM|CCS_NOPARENTALIGN> statusWinTraits;
	typedef CContainedWindowT<CStatusBarCtrl,statusWinTraits> StatusBarObj;
	
	CControlToolBox&			GetToolWindow()			{ return m_wndControlToolBox; }
	CBrowseTabContainer*		GetBrowserContainer()	{ return m_pBrowseTabContainer; }
	StatusBarObj&				GetStatusBar()			{ return m_Status; }	
	CAxWindowHandle*			GetEnvelopeForSite()	{ return m_wndFormSite; }
	CEventDialog&				GetEventDialog()		{ return m_EventDlg; }
	BOOL						IsModeless()			{ return m_bEnableModeless ; }
	LPOLEINPLACEFRAMEINFO		GetInPlaceFrameInfo() ;
	void						SetDirty(bool b);
	
public:
	CInternalComObjectWithData<CForm,CContainerFrame>		*m_pFormObj;
	CComObject<CPropertyBag>								*m_pPropBagObj;	
	
	

private:	
	CEventDialog					m_EventDlg;
	CAxWindowHandle					*m_wndFormSite;
	StatusBarObj					m_Status;
	CBrowseTabContainer				*m_pBrowseTabContainer;
	CControlToolBox					m_wndControlToolBox;
	bool							m_bSavedOnce;
	TCHAR							m_szFileName[1024];
	CComBSTR						m_bstrName;	
	CToolPanel						m_wndToolPanel;
	BOOL							m_bEnableModeless ;
	
	
};

//--------------------------------------------------------------------------------------------------------------------

#endif