//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//Copyright 1999 Dharma Shukla.

//Keep in mind that I wrote this code just for fun :-) 
//Use it at your own risk! 

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#pragma once
#ifndef _SCRIPTSITE_H_
#define _SCRIPTSITE_H_

#include "Base_Include\comobj.H"
#include "resource.H"
#include "activeScriptSite.H"

#include <vector>

#include "Base_Include\ATLControls.H"
using namespace ATLControls;

class CForm;

struct ScriptPair
{
	CComBSTR			m_strName;
	CComPtr<IDispatch>	m_spDispatch;
};

typedef std::vector<ScriptPair*>::iterator itScriptPair; //convert it to a map instead of vec

//----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//quick & dirty scripting on the global scope
//
//
//
//----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

class ATL_NO_VTABLE CScripterWindow :	public CComObjectRoot,
										public IActiveScriptSiteImpl<CScripterWindow>,
										public IActiveScriptSiteWindowImpl<CScripterWindow>,
										public CDialogImpl<CScripterWindow>,	
										public DataHolder<CForm>
							
{
public:
	CScripterWindow();
	~CScripterWindow();

public:
	enum { IDD = IDD_SCRIPTER };


BEGIN_COM_MAP(CScripterWindow)
	COM_INTERFACE_ENTRY(IActiveScriptSite)
	COM_INTERFACE_ENTRY(IActiveScriptSiteWindow)
END_COM_MAP()

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_MSG_MAP(CScripterWindow)
	MESSAGE_HANDLER(WM_CLOSE, OnDestroy)
	COMMAND_ID_HANDLER(IDOK, OnClose)
	COMMAND_ID_HANDLER(IDC_BUTTON_EXECUTE, OnExecuteScript)
END_MSG_MAP()
	

public:
	LRESULT OnExecuteScript(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	
	LRESULT OnClose(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		DestroyWindow();
		return 0L;
	}

	LRESULT OnDestroy(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		if(m_spScript)
			m_spScript->SetScriptState(SCRIPTSTATE_CLOSED);

		DestroyWindow();
		return 0L;
	}

	LRESULT OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	
public:
	    
	HRESULT IActiveScriptSite_GetItemInfo(LPCOLESTR pstrName,DWORD dwReturnMask,IUnknown **ppiunkItem,ITypeInfo **ppti);
	HRESULT IActiveScriptSite_OnStateChange(SCRIPTSTATE ssScriptState);
	HRESULT IActiveScriptSite_OnScriptError(IActiveScriptError *pscripterror);
        
public:
	HRESULT FinalConstruct();
	void	FinalRelease();
	
	HRESULT ExecuteScript();
	HRESULT CreateScriptEngine();
	
	HRESULT CloseEngine()
	{
		if(m_spScript)
		{
			m_spScript->SetScriptState(SCRIPTSTATE_CLOSED);
			m_spScript->Close();
		}
		return S_OK;
	}

	HRESULT UpdateItem(IDispatch* pDisp,CComBSTR& strNewItem,CComBSTR strOldItem = 0, DWORD dwFlags = SCRIPTITEM_ISVISIBLE|SCRIPTITEM_ISSOURCE | SCRIPTITEM_GLOBALMEMBERS);

private:
	CComPtr<IActiveScript>			m_spScript;
	CComPtr<IActiveScriptParse>		m_spScriptParse;
	std::vector<ScriptPair*>		m_vecScriptPair; //convert this to a map

};
//----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
#endif