//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//Copyright 1999 Dharma Shukla.

//Keep in mind that I wrote this code just for fun :-) 
//Use it at your own risk! 

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#include "StdAfx.H"
#include "ContainerFrame.H"
#include "Toolwindow.H"
#include <oledlg.h>
#include "AxControldlg.h"

//--------------------------------------------------------------------------------------------------------------------

UINT CControlToolBox::m_snBtnCount = 0;

//--------------------------------------------------------------------------------------------------------------------

LRESULT CControlToolBox::OnPickDrag(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(!m_pFrame)
	{
		return 0L;
	}
	
	for(itBtnInfo it = m_listBtnInfo.begin() ;it != m_listBtnInfo.end();it++)
	{
		m_wndToolBox.PressButton((*it).m_wID,FALSE);
		if((*it).m_wID == wID)
		{
			m_pFrame->OnToolSelected((*it).m_bstrCLSID);
			//Arrow
			m_wndToolBox.PressButton(100,FALSE);
			//selected btn
			m_wndToolBox.PressButton(wID,TRUE);
			if(m_pFrame && m_pFrame->m_pFormObj)
			{
				m_pFrame->m_pFormObj->CaptureMouse();
			}
			return 0L;
		}
	}

	return 0L;
}
//--------------------------------------------------------------------------------------------------------------------
//
void CControlToolBox::LoadToolBoxBmp(LPOLESTR pszclsid)
{
	USES_CONVERSION;
	CComBSTR bstrclsid(pszclsid);
	
	for(itBtnInfo it = m_listBtnInfo.begin() ;it != m_listBtnInfo.end();it++)
	{
		if((*it).m_bstrCLSID == bstrclsid)
		{
			return ;
		}
	}
		
	TCHAR	szCLSID[256] ;
	
	lstrcpy(szCLSID,_T("CLSID\\"));
	lstrcat(szCLSID,OLE2T(pszclsid));
	
	HKEY	hkClass;
	LONG    cb ;
	TCHAR   szBuf[_MAX_PATH] ;

	::RegOpenKey(HKEY_CLASSES_ROOT,szCLSID,&hkClass) ;
	cb = sizeof(szBuf) ;
	
	if (RegQueryValue( hkClass, (LPTSTR)"ToolboxBitmap32", szBuf, &cb ) == ERROR_SUCCESS ||
		RegQueryValue( hkClass, (LPTSTR)"ToolboxBitmap", szBuf, &cb ) == ERROR_SUCCESS)
	{
		TCHAR * pszBitmapModule = _tcstok(szBuf, _T(","));
		TCHAR * pszBitmapId = _tcstok(NULL, _T(","));
		HINSTANCE hinstBitmap;
		int nBitmapId;
		if ((pszBitmapModule != NULL) && (pszBitmapId != NULL))
		{
			LPTSTR p ;
			if (*pszBitmapModule == '"')
			{
				lstrcpy( pszBitmapModule, pszBitmapModule+1 ) ;
				p = strrchr( pszBitmapModule, '"' ) ;
				if (p) *p = '\0' ;
			}
			nBitmapId = _ttoi(pszBitmapId);
			
			hinstBitmap = ::LoadLibrary(pszBitmapModule);
			
			if (hinstBitmap && (nBitmapId > 0))
			{
				HBITMAP hbmp = ::LoadBitmap(hinstBitmap, MAKEINTRESOURCE(nBitmapId));
				if(!hbmp) //If the ToolBoxBitmap32 does not have a Bitmap we'll give one. We dont accept icons as of this version.
				{
					hbmp = ::LoadBitmap(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDB_FORM));
				}
				if (hbmp)
				{
					RECT rc;GetClientRect(&rc);
					rc.left += 15;
					rc.top+= 15;
					rc.right-= 5;
					rc.bottom-= 5;
										
					m_wndToolBox.SetButtonStructSize(sizeof(TBBUTTON));
					m_wndToolBox.AddBitmap(1,hbmp);
					
					TBBUTTON tb;

					tb.iBitmap = m_snBtnCount; 
					tb.idCommand = 100 + m_snBtnCount; 
					tb.fsState = TBSTATE_ENABLED;
					#pragma warning(disable:4305)
					#pragma warning(disable:4309)
					tb.fsStyle = TBSTYLE_GROUP|TBSTYLE_WRAPABLE|TBSTYLE_CHECK|TBSTYLE_BUTTON ; 
					#pragma warning(default:4305)
					#pragma warning(default:4309)
					tb.dwData = 0; 

					m_wndToolBox.InsertButton(m_snBtnCount,&tb);
					m_snBtnCount++;
					
					//Insert the new guy in the list
					BtnInfo BtnInfo;
					BtnInfo.m_wID		=  tb.idCommand;
					BtnInfo.m_bstrCLSID	=  pszclsid; 
					m_listBtnInfo.push_back(BtnInfo);

					//cleanup
					::DeleteObject(hbmp) ;
				}
				//cleanup
				::FreeLibrary(hinstBitmap) ;
			}
		}
	}
	RegCloseKey(hkClass) ;
}	
//--------------------------------------------------------------------------------------------------------------------


CControlToolBox::CControlToolBox():m_wndToolBox(this,1)
{
	m_hFont	= ::CreateFont(
							8, 0, 0, 0, FW_NORMAL,
							FALSE,FALSE,FALSE,ANSI_CHARSET,
							OUT_DEFAULT_PRECIS,
							CLIP_DEFAULT_PRECIS,
							DEFAULT_QUALITY,DEFAULT_PITCH,
							_T("Ms Sans Serif")
						  );
}
//--------------------------------------------------------------------------------------------------------------------
	
CControlToolBox::~CControlToolBox()
{
	if(m_hFont)
	{
		::DeleteObject(m_hFont);
		m_hFont = NULL;
	}
	m_listBtnInfo.clear();
}
//--------------------------------------------------------------------------------------------------------------------

LRESULT CControlToolBox::OnRBtnDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	CContextMenu cm;
	cm.Load(_Module.GetModuleInstance(),IDR_MENU1);
	POINT pt;
	pt.x = LOWORD(lParam);
	pt.y = HIWORD(lParam);
	::ClientToScreen(m_hWnd,&pt);
	cm.TrackSubMenu(pt.x+80,pt.y,m_hWnd);
	cm.Destroy();
	return 0L;
}
//--------------------------------------------------------------------------------------------------------------------
	
LRESULT CControlToolBox::OnMenuClick(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	CAXControlInsertDialog dlg;
	dlg.DoModal();
	LPOLESTR pszClsid = NULL;
	::StringFromCLSID(dlg.m_clsid, &pszClsid);
	
	USES_CONVERSION;
	CComBSTR bstrclsid = OLE2BSTR(pszClsid);
	
	for(itBtnInfo it = m_listBtnInfo.begin() ;it != m_listBtnInfo.end();it++)
	{
		if((*it).m_bstrCLSID == bstrclsid)
		{
			::CoTaskMemFree(pszClsid);
			return 0L;
		}
	}
	
	LoadToolBoxBmp(pszClsid);
	::CoTaskMemFree(pszClsid);

	/* The following snippets use the OLEUI library's dialog. In case you want to use it
	instead of our home grown insert control dialog :-)

	OLEUIINSERTOBJECT   io;
	TCHAR               szFile[_MAX_PATH];

	ZeroMemory(&io, sizeof(io));
	io.cbStruct = sizeof(io);
	szFile[0] = 0;
	io.lpszFile = szFile;
	io.cchFile = _MAX_PATH;
	io.dwFlags = IOF_DISABLELINK | IOF_DISABLEDISPLAYASICON | IOF_SHOWINSERTCONTROL | IOF_SELECTCREATECONTROL;

	if (::OleUIInsertObject(&io) == OLEUI_OK)
	{
		if (io.dwFlags & IOF_CREATELINKOBJECT)
			MessageBox(_T("Sorry. Creation from a file is not currently supported."));
		else
		{
			LPOLESTR pszClsid = NULL;
			::StringFromCLSID(io.clsid, &pszClsid);
			
			USES_CONVERSION;
			CComBSTR bstrclsid = OLE2BSTR(pszClsid);
			
			for(itBtnInfo it = m_listBtnInfo.begin() ;it != m_listBtnInfo.end();it++)
			{
				if((*it).m_bstrCLSID == bstrclsid)
				{
					::CoTaskMemFree(pszClsid);
					return 0L;
				}
			}
			
			LoadToolBoxBmp(pszClsid);
			::CoTaskMemFree(pszClsid);
		}
	}*/

	return 0;
}
//--------------------------------------------------------------------------------------------------------------------

LRESULT CControlToolBox::OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	//change the styles
	ModifyStyle(GetStyle(), WS_OVERLAPPEDWINDOW|WS_VISIBLE| 
							 WS_CLIPSIBLINGS |WS_CLIPCHILDREN |
							 WS_OVERLAPPED);
			
		
	ModifyStyleEx(GetExStyle(),WS_EX_LEFT|WS_EX_LTRREADING|
								WS_EX_RIGHTSCROLLBAR|
								WS_EX_TOOLWINDOW|WS_EX_WINDOWEDGE);
		
	::SetClassLong(m_hWnd,GCL_STYLE,CS_NOCLOSE);

	RECT rc;
	GetClientRect(&rc);
	rc.left += 5;
	rc.top  += 5;
	rc.right= rc.left + 80;
	rc.bottom= rc.top + 500;
	m_wndToolBox.Create(m_hWnd,rc);
	m_wndToolBox.SetButtonStructSize(sizeof(TBBUTTON));
	m_wndToolBox.AddBitmap(1,BMP_ARROW);
	TBBUTTON tb;

	tb.iBitmap = 0; 
	tb.idCommand = 100 + m_snBtnCount; 

	#pragma warning(disable:4305)
	#pragma warning(disable:4309)
	tb.fsState = TBSTATE_ENABLED| TBSTATE_PRESSED;
	tb.fsStyle = tb.fsStyle = TBSTYLE_GROUP|TBSTYLE_WRAPABLE|TBSTYLE_CHECK|TBSTYLE_BUTTON ; 
	#pragma warning(default:4305)
	#pragma warning(default:4309)
	tb.dwData = 0; 
	m_wndToolBox.InsertButton(0,&tb);
	
	//This is the first toolbox btn
	m_snBtnCount++;
	return 0;
}
//--------------------------------------------------------------------------------------------------------------------
LRESULT CControlToolBox::OnRelayToolTip(int idCtrl, LPNMHDR pnmh, BOOL& bHandled)
{
	LPTOOLTIPTEXT lpTTText = (LPTOOLTIPTEXT)pnmh;
	
	TBBUTTON tb;
	m_wndToolBox.GetButton(idCtrl - 100,&tb);

	for(itBtnInfo it = m_listBtnInfo.begin() ;it != m_listBtnInfo.end();it++)
	{
		if(tb.idCommand == (*it).m_wID)
		{
			CLSID clsid;
			HRESULT hr = ::CLSIDFromString((*it).m_bstrCLSID,&clsid);
			if(SUCCEEDED(hr))
			{
				LPOLESTR psz = 0;
				::ProgIDFromCLSID(clsid, &psz);
				
				wcstok(psz, L".");
							
				USES_CONVERSION;
				lstrcpy( lpTTText->lpszText,OLE2T(wcstok(NULL, L".")) );

				CoTaskMemFree(psz); psz = 0;
				
				bHandled = TRUE;
				return 0L;
			}
		}
	}
	
	bHandled = FALSE;
	return 0L;		
}

//--------------------------------------------------------------------------------------------------------------------
